<?php

/*
Plugin Name: Event Cats
Version: 1.2.3
Description: A single URL can be enough to be identified, and a user can duplicate his account to create a new one getting immediately the same properties. / On peut être identifié grâce à un simple URL, et on peut dupliquer son compte pour créer un nouveau compte ayant immédiatement les mêmes propriétés.
Plugin URI: http://piwigo.org/ext/extension_view.php?eid=326
Author: LucMorizur
Author URI: http://lucmorizur.free.fr
*/

// +-----------------------------------------------------------------------+
// | Piwigo - a PHP based picture gallery                                  |
// +-----------------------------------------------------------------------+
// | Copyright(C) 2008-2009 Piwigo Team                  http://piwigo.org |
// | Copyright(C) 2003-2008 PhpWebGallery Team    http://phpwebgallery.net |
// | Copyright(C) 2002-2003 Pierrick LE GALL   http://le-gall.net/pierrick |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

// Keeps file coded in UTF-8 without BOM: é

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

// pour faciliter le debug - make debug easier :o)
//ini_set('error_reporting', E_ALL);
//ini_set('display_errors', true);

global $conf, $prefixeTable, $ec_lists, $template;

define( // -------------------------------------------------------------------
  'EVNTCATS_INFO_VERSION', // VERSION HISTORY:
   '1.2.3' // Re-fix bug 1432 :-/ ...
// '2.1.0' // When done, will simplfy and allow EC management from categories
//            management pages in admin pages... yes yes...
// '1.2.2' // Corrections for Piwigo 2.1 compatibility
// '1.2.1' // Improve EN translation thanks to Tosca
// '1.2.0' // Add feature 1335, Possibility to display the 'Connection'
//         // link in identification block menu for generic users;
//         // finish (yes !) english translation
// '1.1.5' // Fix bugs 1324 and 1325
// '1.1.4' // Improve help banner
// '1.1.3' // Better help banner management; finalize banner texts
// '1.1.2' // Better help banner example: some examples
// '1.1.1' // Better help banner example; but still no text in it
// '1.1.0' // First bugs (1305 and 1306) corrected;
           // add newly created user/group association with cat/AP (was
           // forgotten); begin help banner
// '1.0.0' // Conception version
); // ------------------------------------------------------------------------
define(
  'EVNTCATS_PATH',
   PHPWG_PLUGINS_PATH.basename(dirname(__FILE__)).'/'
);
define(
  'EVNTCATS_TABLE',
   $prefixeTable.'event_cats'
);
define(
  'ROOT_URL',
   get_absolute_root_url()
);

include_once(EVNTCATS_PATH.'include/evntcats_main_funcs.inc.php');

class event_cats {
// Sets the administration panel of the plugin
  function plugin_admin_menu($menu) {
    array_push($menu,
      array(
        'NAME' => 'Event Cats',
        'URL'  => get_admin_plugin_menu_link(dirname(__FILE__).
                  '/admin/evntcats_admin.php')
      )
    );
    return $menu;
  }
} // End class

$obj = new event_cats();

// Adds the translation of "duplicate" link
load_language('duplic.lang', EVNTCATS_PATH);

// Admin help management
add_event_handler('get_popup_help_content', 'ec_popup_help_content',
 EVENT_HANDLER_PRIORITY_NEUTRAL, 2);

function ec_popup_help_content($popup_help_content, $page) {
  return (
   $help_content = (is_admin() and $page == 'help') ?
    load_language($page.'.html',EVNTCATS_PATH,array('return' => true)) : false
  ) ? $popup_help_content.$help_content : $popup_help_content;
}

//----------------------------------

/**
 *
 * auto_log_user()
 * the function uses the value of the argument "autolog" of the posted URL,
 * as a code to know which username has to be logged in.
 *
 * @param no parameter
 * @return no return value
 */

add_event_handler('init', 'auto_log_user');

function auto_log_user() {
  global $ec_lists;

  $ec_ap  = NULL;
  $ec_cat = NULL;
  $ec_img = NULL;
  
  if (isset($_GET['autolog']) and (read_ec_conf('activated') == '1')) {
    if (!is_a_guest()) {
      $url = '';
      foreach ($_GET as $item => $value) {
        $url.= '&'.$item.'='.$value;
      }
      logout_user();
      redirect(make_index_url().$url);
    }
    build_ec_lists();
    foreach ($ec_lists['ec_table'] as $ec_entry) {
      if ($code_exists = ($ec_entry['code'] == $_GET['autolog'])) break;
    }
    if ($code_exists) {
      if (is_in($ec_entry['action'], 'ec_ok')) {
        log_user($ec_entry['user_id'], false);
        if (isset($_GET['ap'])) $ec_ap = $_GET['ap'];
        if (isset($_GET['cat'])) $ec_cat = $_GET['cat'];
        if (isset($_GET['img'])) $ec_img = $_GET['img'];
        if ($ec_entry['forced'] == 'true') {
          if (empty($ec_entry['arg1']) and !empty($ec_entry['arg2'])) {
            $ec_ap = $ec_entry['arg2'];
          }
          elseif (!empty($ec_entry['arg1'])) {
            $ec_cat = $ec_entry['arg1'];
            if (!empty($ec_entry['arg2'])) $ec_img = $ec_entry['arg2'];
          }
        }
        if (isset($ec_ap)) {
          if (array_key_exists($ec_ap,$ec_lists['add_pages'])) {
            redirect(
             PHPWG_ROOT_PATH.'index.php?/additional_page/'.$ec_ap);
          }
        }
        elseif (isset($ec_cat)) {
          if (array_key_exists($ec_cat, $ec_lists['categories'])) {
            if (isset($ec_img)) {
              if (ec_image_exists($ec_cat, $ec_img)) {
       redirect(PHPWG_ROOT_PATH.'picture.php?/'.$ec_img.'/category/'.$ec_cat);
              }
            }
            redirect(PHPWG_ROOT_PATH.'index.php?/category/'.$ec_cat);
          }
        }
        redirect(make_index_url());
      }
      else {
        if (
         $ec_entry['action'] == 'ec_nok' or
         $ec_entry['action'] == 'ec_nok_ap_pb'
        ) {
          if ($ec_entry['action'] == 'ec_nok_ap_pb') access_denied();
          $ec_ap = $ec_entry['arg2'];
          if (array_key_exists($ec_ap, $ec_lists['add_pages'])) {
            redirect(
             PHPWG_ROOT_PATH.'index.php?/additional_page/'.$ec_ap);
          }
          access_denied();
        }
        else {
          redirect(make_index_url());
        }
      }
    }
    else {
      if (
       read_ec_conf('unknown_code') == '2' and
        array_key_exists(
         read_ec_conf('unknown_code_ap_id'), $ec_lists['add_pages']
        )
       ) {
        redirect(
         PHPWG_ROOT_PATH.
         'index.php?/additional_page/'.read_ec_conf('unknown_code_ap_id')
        );
      }
      elseif (read_ec_conf('unknown_code') == '1' or
       read_ec_conf('unknown_code') == '2') {
        access_denied();
      }
      else {
        redirect(make_index_url());
      }
    }
  }
}

/**
 *
 * assign_perm_for_new_user()
 * copies/paste groups+access+properties associations of previously connected
 * username, to newly created username.
 *
 * @param no parameter
 * @return no return value
 */

add_event_handler('register_user', 'assign_perm_for_new_user');

function assign_perm_for_new_user($new_user) {
  global $user;

  if (read_ec_conf('activated') == '1') {
    if (
      !is_a_guest() and !is_admin() and (
        read_ec_conf('dup_allow') == '1' or (
          read_ec_conf('dup_allow') == '2' and (
            dup_allowed($user['id']) or (
              read_ec_conf('simple_mode_on') == '1' and
              is_generic()
            )
          )
        )
      )
    ) {
      // User access
      $result = pwg_query("
        SELECT `cat_id`
        FROM `".USER_ACCESS_TABLE."`
        WHERE `user_id` = ".$user['id'].";
      ");
      $insert = array();
      while ($row = pwg_db_fetch_assoc($result))
       $insert[] = "(".$new_user['id'].",".$row['cat_id'].")";
      if (!empty($insert)) pwg_query("
        INSERT INTO `".USER_ACCESS_TABLE."`
        VALUES ".implode(',', $insert).";
      ");

      // User groups
      $result = pwg_query("
        SELECT `group_id`
        FROM `".USER_GROUP_TABLE."`
        WHERE `user_id` = ".$user['id'].";
      ");
      $insert = array();
      while ($row = pwg_db_fetch_assoc($result))
       $insert[] = "(".$new_user['id'].",".$row['group_id'].")";
      if (!empty($insert)) pwg_query("
        INSERT INTO `".USER_GROUP_TABLE."`
        VALUES ".implode(',', $insert).";
      ");

      // User infos
      $result = pwg_query("
        SELECT `level`
        FROM `".USER_INFOS_TABLE."`
        WHERE `user_id` = ".$user['id'].";
      ");
      $insert = array();
      while ($row = pwg_db_fetch_assoc($result))
       $insert[] = "(".$new_user['id'].",".$row['level'].")";
      if (!empty($insert)) pwg_query("
        UPDATE `".USER_INFOS_TABLE."`
        SET `level` = ".$user['level']."
        WHERE `user_id` = ".$new_user['id'].";
      ");
    }
  }
}

/**
 *
 * duplicate_account_url()
 * adds a link for duplicating the currently identified user in
 * Identification block menu, in case the identifed user is granted to
 * duplication. Displays also the connection link for generic users, if
 * required in the configuration.
 *
 * ec_duplicate_prefilter
 * is used to modify the "quick connect" block in identification menu block,
 * so that visitors identifying themselves this way, are redirected to the
 * page they're currently displaying, instead of home page. This
 * functionnality has been added at version 2.1.0 in Piwigo core
 * (see bug:1484 Redirection after quickconnect), thus it is useless to
 * implement it from here for Piwigo versions higher or equal to 2.1.0.
 *
 * @param no parameter
 * @return no return value
 */

add_event_handler('blockmanager_apply', 'duplicate_account_url');

function ec_duplicate_prefilter($content, &$smarty) {
  $search = "<legend>{'Quick connect'|@translate}</legend>";
  $addon = '<input type="hidden" name="redirect" value="{$U_REDIRECT}">';
  $replacement = "<legend>{'Quick connect'|@translate}</legend>".$addon;
  return str_replace($search, $replacement, $content);
}

function duplicate_account_url() {
  global $lang, $template, $user;
  
  if (read_ec_conf('activated') == '1') {
    if (version_compare(PHPWG_VERSION, '2.1.0', '<')) {
      // Makes the "quick connect" fieldset able to redirect to current page
      // after user identification, just as does the "connection" link.
      $template->assign(array('U_REDIRECT' => $_SERVER['REQUEST_URI']));
      $template->set_prefilter('menubar', 'ec_duplicate_prefilter');
    }
    
    // Add duplication link, if needed
    if (
      !is_admin() and !is_a_guest() and (
        read_ec_conf('dup_allow') == '1' or (
          read_ec_conf('dup_allow') == '2' and (
            dup_allowed($user['id']) or (
              read_ec_conf('simple_mode_on') == '1' and
              is_generic()
            )
          )
        )
      )
    ) {
      $template->assign('U_REGISTER', get_root_url().'register.php');
      if (
        read_ec_conf('duplic_display') == '1' or (
          read_ec_conf('duplic_display') == '2' and
          !is_generic()
        )
      ) {
        $lang['Register'] = $lang['Duplicate'];
        $lang['Create a new account'] =
         $lang['Create a new account with same properties'];
      }
    }
    
    // Adds connection link, if needed
    if (read_ec_conf('display_connection') == '1' and is_generic()) {
      // Adds connection link
      $template->assign(
        'U_LOGIN',
        get_root_url().'identification.php?redirect='.$_SERVER['REQUEST_URI']
      );
    }
  }
}

add_event_handler(
 'get_admin_plugin_menu_links',
 array(&$obj, 'plugin_admin_menu')
);
set_plugin_data($plugin['id'], $obj);

?>